rem @echo off
set JAVAC=javac
set OPTION=-Xdepend -J-mx64m
set TARGET_DIR=lib
set CLASSDIR=bin\lib\jai_codec.jar;bin\lib\jai_core.jar;bin\lib\jmf.jar;bin\lib\jmfbean.jar;bin\lib\mlibwrapper_jai.jar;bin\lib\xml4j.jar;bin\lib\xml4jSamples.jar;%TARGET_DIR%

set SRC_GUIDIR=src\did\gui
set SRC_IODIR=src\did\io
set SRC_XMLDIR=src\did\xml

set SRC_GUI=%SRC_GUIDIR%\DIDBaseRoi.java %SRC_GUIDIR%\DIDCreationHandler.java %SRC_GUIDIR%\DIDEditHandler.java %SRC_GUIDIR%\DIDFindMsgBox.java %SRC_GUIDIR%\DIDImageCanvas.java %SRC_GUIDIR%\DIDInfoPanel.java %SRC_GUIDIR%\DIDInputMethod.java %SRC_GUIDIR%\DIDKeyBDisplay.java %SRC_GUIDIR%\DIDMultTextArea.java %SRC_GUIDIR%\DIDOcrCanvas.java %SRC_GUIDIR%\DIDPolyRoi.java %SRC_GUIDIR%\DIDProperties.java %SRC_GUIDIR%\DIDRectRoi.java %SRC_GUIDIR%\DIDRoiIFC.java %SRC_GUIDIR%\DIDRussianInputMethod.java %SRC_GUIDIR%\DIDSelectionHandler.java %SRC_GUIDIR%\DIDUnicodeEditor.java %SRC_GUIDIR%\DIDUnicodeTable.java %SRC_GUIDIR%\TrueViz.java

set SRC_IO=%SRC_IODIR%\DIDFileFilter.java %SRC_IODIR%\DOMParserWrapper.java %SRC_IODIR%\DOMWriter.java

set SRC_XML=%SRC_XMLDIR%\DIDDefaultTreeModel.java %SRC_XMLDIR%\DIDEntityType.java %SRC_XMLDIR%\DIDNode.java %SRC_XMLDIR%\DIDTree.java %SRC_XMLDIR%\DIDTreeCellEditor.java %SRC_XMLDIR%\DIDTreeCellRenderer.java %SRC_XMLDIR%\DIDTreeModelListener.java %SRC_XMLDIR%\DIDTreeSelectionListener.java

set TMP=%1

if NOT DEFINED TMP ( goto JAR )

if %1==jar ( goto JAR )
if %1==class ( goto CLASS )
if %1==doc ( goto DOC )
if %1==clean ( goto CLEAN )

goto QUIT

:JAR
%JAVAC% %OPTION% -classpath %CLASSDIR% -d %TARGET_DIR% %SRC_GUI% %SRC_IO% %SRC_XML%
cd %TARGET_DIR%
jar cmf MANIFEST.MF TrueViz.jar did
move TrueViz.jar ../bin
cd ..

goto QUIT

:CLASS
%JAVAC% %OPTION% -classpath %CLASSDIR% -d %TARGET_DIR% %SRC_GUI% %SRC_IO% %SRC_XML%

goto QUIT

:DOC
%JAVAC% %OPTION% -classpath %CLASSDIR% -d %TARGET_DIR% %SRC_GUI% %SRC_IO% %SRC_XML%
javadoc -classpath %CLASSDIR% -d docs\api %SRC_GUI% %SRC_IO% %SRC_XML%

goto QUIT

:CLEAN
del /Q/F %TARGET_DIR%\did\gui\* %TARGET_DIR%\did\io\* %TARGET_DIR%\did\xml\*

goto QUIT


:QUIT

