package did.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import did.gui.TrueViz;
import did.gui.DIDImageCanvas;

/*******************************************************************************
*<pre>
*File:         DIDControlBar.java
*Version:      1.0
*Description:  
*Modification Log:
*Date          Name    Comment
*xx-xx-xxxx    XXX         xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*</pre>
*******************************************************************************/

public class DIDControlBar extends JPanel implements ActionListener {
	private JLabel mousePos = null;
	private JComboBox scaleList;
	private TrueViz	myFrame;
	private DIDImageCanvas myCanvas;

	public DIDControlBar(TrueViz frame, DIDImageCanvas canvas) {
		myFrame = frame;
		myCanvas = canvas;
		mousePos = new JLabel("(0, 0)");
		String[] data = {"Width", "Height", "150%", "125%", "100%",
				"75%", "50%", "25%"};
		scaleList = new JComboBox(data);
		scaleList.addActionListener(this);

		((FlowLayout)getLayout()).setAlignment(FlowLayout.LEFT);
		add(new JLabel("Scale: "));
		add(scaleList);
		add(new JSeparator(SwingConstants.VERTICAL));
		add(new JLabel("Mouse Postion: "));
		add(mousePos);
	}

	public String getScale() {
		return (String)scaleList.getSelectedItem();
	}

	public void setMousePos(int x, int y) {
		mousePos.setText(new String(x + ", " + y));
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand() == "comboBoxChanged") {
			if (scaleList.getSelectedItem() == "Width") {
				myFrame.fitWidth();
			} else if (scaleList.getSelectedItem() == "Height") {
				myFrame.fitHeight();
			} else if (scaleList.getSelectedItem() == "150%") {
				myCanvas.changeScale(1.5f);
			} else if (scaleList.getSelectedItem() == "125%") {
				myCanvas.changeScale(1.25f);
			} else if (scaleList.getSelectedItem() == "100%") {
				myCanvas.changeScale(1.0f);
			} else if (scaleList.getSelectedItem() == "75%") {
				myCanvas.changeScale(0.75f);
			} else if (scaleList.getSelectedItem() == "50%") {
				myCanvas.changeScale(0.50f);
			} else if (scaleList.getSelectedItem() == "25%") {
				myCanvas.changeScale(0.25f);
			}
		}
	}
}


