package did.gui;

import java.awt.*;
import java.awt.geom.*;
import java.lang.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

public class DIDKeyBDisplay extends JFrame {
	protected static final int WID = 40, HGT = 40;
	JPanel panel = new JPanel();
	JPanel Row1 = new JPanel();
	JPanel Row2 = new JPanel();
	JPanel Row3 = new JPanel();
	JPanel Row4 = new JPanel();
	JPanel Row5 = new JPanel();

	public char orgRow1[] = {
		'`', '1', '2', '3', '4', '5', '6', '7', '8', '9',
		'0', '-', '=', '\\'
		};
	public char orgRow2[] = {
		'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P',
		'[', ']'
		};
	public char orgRow3[] = {
		'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ';',
		'\''
		};
	public char orgRow4[] = {
		'Z', 'X', 'C', 'V', 'B', 'N', 'M', ',', '.', '/'
		};

	public char currRow1[] = null;
	public char currRow2[] = null;
	public char currRow3[] = null;
	public char currRow4[] = null;

	public char shiftRow1[] = null;
	public char shiftRow2[] = null;
	public char shiftRow3[] = null;
	public char shiftRow4[] = null;

	private KeyCap row1Keys[] = new KeyCap[14];
	private KeyCap row2Keys[] = new KeyCap[14];
	private KeyCap row3Keys[] = new KeyCap[13];
	private KeyCap row4Keys[] = new KeyCap[12];
	private KeyCap row5Keys[] = new KeyCap[7];

	public DIDKeyBDisplay() {
		super("Keyboard Mapping");
		//getContentPane().add(this);
		setSize(580, 220);
		//frame.pack();
		init();
		//show();
	}

	public void init() {
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		Row1.setLayout(new BoxLayout(Row1, BoxLayout.X_AXIS));
		Row2.setLayout(new BoxLayout(Row2, BoxLayout.X_AXIS));
		Row3.setLayout(new BoxLayout(Row3, BoxLayout.X_AXIS));
		Row4.setLayout(new BoxLayout(Row4, BoxLayout.X_AXIS));
		Row5.setLayout(new BoxLayout(Row5, BoxLayout.X_AXIS));

		for (int i=0; i < 14; i++) {
			row1Keys[i] = new KeyCap();
		//	row1Keys[i].setMapping((char)('1'+i),'a','A');
			Row1.add(Box.createRigidArea(new Dimension(2, 2)));
			Row1.add(row1Keys[i]);
		}

		row2Keys[0] = new KeyCap();
		row2Keys[0].setBackground(row2Keys[0].getBackground().darker());
		row2Keys[0].setSizes((int)(WID*1.5), HGT);
		Row2.add(Box.createRigidArea(new Dimension(3, 2)));
		Row2.add(row2Keys[0]);
		for (int i=1; i < 13; i++) {
			row2Keys[i] = new KeyCap();
			//row2Keys[i].setMapping((char)('1'+i),'a','A');
			Row2.add(Box.createRigidArea(new Dimension(2, 2)));
			Row2.add(row2Keys[i]);
		}
		row2Keys[13] = new KeyCap();
		row2Keys[13].setBackground(row2Keys[13].getBackground().darker());
		Row2.add(Box.createRigidArea(new Dimension(4, 2)));
		Row2.add(row2Keys[13]);

		row3Keys[0] = new KeyCap();
		row3Keys[0].setBackground(row3Keys[0].getBackground().darker());
		row3Keys[0].setSizes((int)(WID*1.5), HGT);
		Row3.add(Box.createRigidArea(new Dimension(3, 2)));
		Row3.add(row3Keys[0]);
		for (int i=1; i < 12; i++) {
			row3Keys[i] = new KeyCap();
			//row3Keys[i].setMapping((char)('1'+i),'a','A');
			Row3.add(Box.createRigidArea(new Dimension(2, 2)));
			Row3.add(row3Keys[i]);
		}
		row3Keys[12] = new KeyCap();
		row3Keys[12].setBackground(row3Keys[12].getBackground().darker());
		row3Keys[12].setSizes(WID*2, HGT);
		Row3.add(Box.createRigidArea(new Dimension(4, 2)));
		Row3.add(row3Keys[12]);

		row4Keys[0] = new KeyCap();
		row4Keys[0].setBackground(row4Keys[0].getBackground().darker());
		row4Keys[0].setSizes((int)(WID*1.5), HGT);
		Row4.add(Box.createRigidArea(new Dimension(3, 2)));
		Row4.add(row4Keys[0]);
		for (int i=1; i < 11; i++) {
			row4Keys[i] = new KeyCap();
			//row4Keys[i].setMapping((char)('1'+i),'a','A');
			Row4.add(Box.createRigidArea(new Dimension(2, 2)));
			Row4.add(row4Keys[i]);
		}
		row4Keys[11] = new KeyCap();
		row4Keys[11].setBackground(row4Keys[11].getBackground().darker());
		row4Keys[11].setSizes(WID*2, HGT);
		Row4.add(Box.createRigidArea(new Dimension(4, 2)));
		Row4.add(row4Keys[11]);

		for (int i=0; i < 3; i++) {
			row5Keys[i] = new KeyCap();
			row5Keys[i].setBackground(row5Keys[i].getBackground().darker());
		//	Row5.add(Box.createRigidArea(new Dimension(1, 2)));
			Row5.add(row5Keys[i]);
		}
		row5Keys[3] = new KeyCap();
		row5Keys[3].setSizes(WID*7, HGT);
		Row5.add(Box.createRigidArea(new Dimension(14, 2)));
		Row5.add(row5Keys[3]);
		for (int i=4; i < 7; i++) {
			row5Keys[i] = new KeyCap();
			row5Keys[i].setBackground(row5Keys[i].getBackground().darker());
			Row5.add(Box.createRigidArea(new Dimension(1, 2)));
			Row5.add(row5Keys[i]);
		}

		setOrgs();

		panel.add(Row1);
		panel.add(Row2);
		panel.add(Row3);
		panel.add(Row4);
		panel.add(Row5);
		getContentPane().add(panel);
		repaint();
	}


	public void setOrgs() {
		for (int i=0; i < 14; i++) {
			row1Keys[i].setOrg(orgRow1[i]);
		}
		for (int i=1; i < 13; i++) {
			row2Keys[i].setOrg(orgRow2[i-1]);
		}
		for (int i=1; i < 12; i++) {
			row3Keys[i].setOrg(orgRow3[i-1]);
		}
		for (int i=1; i < 11; i++) {
			row4Keys[i].setOrg(orgRow4[i-1]);
		}
	}

	public void setCurrs() {
		for (int i=0; i < 14; i++) {
			row1Keys[i].setCurr(currRow1[i]);
		}
		for (int i=1; i < 13; i++) {
			row2Keys[i].setCurr(currRow2[i-1]);
		}
		for (int i=1; i < 12; i++) {
			row3Keys[i].setCurr(currRow3[i-1]);
		}
		for (int i=1; i < 11; i++) {
			row4Keys[i].setCurr(currRow4[i-1]);
		}
	}

	public void setShifts() {
		for (int i=0; i < 14; i++) {
			row1Keys[i].setShift(shiftRow1[i]);
		}
		for (int i=1; i < 13; i++) {
			row2Keys[i].setShift(shiftRow2[i-1]);
		}
		for (int i=1; i < 12; i++) {
			row3Keys[i].setShift(shiftRow3[i-1]);
		}
		for (int i=1; i < 11; i++) {
			row4Keys[i].setShift(shiftRow4[i-1]);
		}
	}


	class KeyCap extends JPanel {
		protected String orgKey = new String();
		protected String currKey = new String();
		protected String shiftKey = new String();

		int capWid = WID;
		int capHgt = HGT;

		public KeyCap() {
			super();
			setBorder(BorderFactory.createRaisedBevelBorder());
			setSizes(capWid, capHgt);
		}

		public KeyCap(String org, String curr, String shift) {
			super();
			setBorder(BorderFactory.createRaisedBevelBorder());
			setSizes(capWid, capHgt);
			orgKey = org;
			currKey = curr;
			shiftKey = shift;
		}

		public void setSizes(int w, int h) {
			capWid = w;
			capHgt = h;
			setMinimumSize(new Dimension(capWid, capHgt));
			//setMaximumSize(new Dimension(capWid, capHgt));
			//setSize(w, h);
			repaint();
		}

		public void setOrg(char org) {
			orgKey = (new Character(org)).toString();
			repaint();
		}

		public void setCurr(char curr) {
			currKey = (new Character(curr)).toString();
			repaint();
		}

		public void setShift(char shift) {
			shiftKey = (new Character(shift)).toString();
			repaint();
		}

		public void setMapping(char org, char curr, char shift) {
			orgKey = (new Character(org)).toString();
			currKey = (new Character(curr)).toString();
			shiftKey = (new Character(shift)).toString();
			repaint();
		}

		public void setMapping(String title) {
			orgKey = title;
			currKey = "";
			shiftKey = "";
			repaint();
		}

		public void paintComponent(Graphics g) {
			int x = 3, y = 16;
			super.paintComponent(g);
			Graphics2D g2d = (Graphics2D)g;

			g2d.setColor(Color.black);
			setFontSize((int)(capHgt/4));
			g2d.drawString(orgKey, x+0, y+0);
			g2d.setColor(Color.blue);
			setFontSize((int)(2*capHgt/5));
			g2d.drawString(shiftKey, x+capHgt/2, y+0);
			g2d.drawString(currKey, x+capHgt/2, y+capHgt/2);
		}

		public void setFontSize(int fontsize) {
                	Font newFont = new Font(getFont().getName(),
				getFont().getStyle(), fontsize);
	                setFont(newFont);
		}

	} //end of class KeyCap
}
