package did.xml;

import java.util.Vector;
import java.util.Enumeration;

/*******************************************************************************
*<pre>
*File:         DIDEntityType.java
*Version:      1.0
*Description:  
*
*Modification Log:
*Date          Name    Comment
*xx-xx-xxxx    XXX	   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*</pre>
*******************************************************************************/

public class DIDEntityType {
	public static final int UNDETERMINED = -2;
	public static final int UNSPECIFIED = -1;
	public static final int PAGE = 0;
	public static final String PAGENAME = "Page";
	public static final String OTHER = "Other";
	private static final int builtInNum = 4;
	public String EntityTypeNames[] = {"Zone", "Line", "Word", "Character"};
	public int EntityTypes[] = { 1, 2, 3, 4 };
	protected int length = 4;
//DOCUMENT = "Document", PAGE = "Page", ZONE = "Zone", WORD = "Word", LINE = "Line", CHARACTER = "Character", VERTEX = "Vertex", OTHER = "Other";

	/***********************************************************************
	* Method used to instantiate this class.
	***********************************************************************/
	public DIDEntityType() {
	}

	/***********************************************************************
	* 
	* @param
	* @return if the type name is not found, return null.
	***********************************************************************/
	public void add(String name) {
		String newNames[] = new String[length+1];
		int newTypes[] = new int[length+1];
		int maxType = 0;

		for (int i=0; i < length; i++) {
			if (EntityTypeNames[i].equalsIgnoreCase(name)) {
				return;
			} else {
				newNames[i] = EntityTypeNames[i];
				newTypes[i] = EntityTypes[i];
				if (EntityTypes[i] > maxType) {
					maxType = EntityTypes[i];
				}
			}
		}

		newNames[length] = name;
		newTypes[length] = maxType + 1;
		length++;
		EntityTypeNames = newNames;
		EntityTypes = newTypes;
/*DEL*/ for(int i=0; i< length; i++) {
/*DEL*/System.out.println(EntityTypeNames[i]+": "+EntityTypes[i]);  }
	}

	/***********************************************************************
	* Method to get the name of entity type from the index of the array
	* storing entity type names.
	* @param
	* @return
	***********************************************************************/
	public String getName(int index) { 
		if (index >= 0 && index < length) {
			return (EntityTypeNames[index]);
		} else {
			return null;
		}
	}

	/***********************************************************************
	* 
	* @param
	* @return if the type name is not found, return null.
	***********************************************************************/
	public String typeToName(int num) { 
		for (int i=0; i < length; i++)  {
			if (EntityTypes[i] == num) {
				return (EntityTypeNames[i]);
			}
		}

		return null;
	}

	/***********************************************************************
	* Method to get type number from type name
	* @param
	* @return if the type name is not found, return UNDETERMINED.
	***********************************************************************/
	public int nameToType(String name) { 
		for (int i=0; i < length; i++)  {
			if (EntityTypeNames[i].equalsIgnoreCase(name)) {
				return (EntityTypes[i]);
			}
		}

		return UNDETERMINED;
	}

	/***********************************************************************
	* Method to get type number from index
	* @param
	* @return if the type name is not found, return UNDETERMINED.
	***********************************************************************/
	public int getType(int index) { 
		if (index >= 0 && index < length) {
			return (EntityTypes[index]);
		}
		else {
			return UNDETERMINED;
		}
	}

	/***********************************************************************
	* Method to get index from type name
	* @param
	* @return if the type name is not found, return UNDETERMINED.
	***********************************************************************/
	public int getIndex(String name) { 
		for (int i=0; i < length; i++)  {
			if (EntityTypeNames[i].equalsIgnoreCase(name)) {
				return i;
			}
		}

		return UNDETERMINED;
	}

	/***********************************************************************
	* Method to get index from type num
	* @param
	* @return if the type name is not found, return UNDETERMINED.
	***********************************************************************/
	public int getIndex(int num) { 
		for (int i=0; i < length; i++)  {
			if (EntityTypes[i] == num) {
				return i;
			}
		}

		return UNDETERMINED;
	}

	/***********************************************************************
	* 
	* @param
	* @return
	***********************************************************************/
	public Enumeration getTypeNames() { 
		Vector v = new Vector();

		for (int i=0; i < length; i++)  {
			v.add(EntityTypeNames[i]);
		}

		return (v.elements());
	}

	/***********************************************************************
	* 
	* @param
	* @return
	***********************************************************************/
	public Enumeration getBuiltInTypeNames() { 
		Vector v = new Vector();

		for (int i=0; i < builtInNum; i++)  {
			v.add(EntityTypeNames[i]);
		}

		return (v.elements());
	}

	/***********************************************************************
	* 
	* @param
	* @return
	***********************************************************************/
	public boolean isValid(String name) { 
		for (int i=0; i < length; i++)  {
			if (EntityTypeNames[i].equalsIgnoreCase(name)) {
				return true;
			}
		}

		return false;
	}

	/***********************************************************************
	* 
	* @param
	* @return
	***********************************************************************/
	public boolean ancestor(int type1, int type2) { 
		if (getIndex(type1) < getIndex(type2)) {
			return true;
		} else {
			return false;
		}
	}

	/***********************************************************************
	* 
	* @param
	* @return
	***********************************************************************/
	public int length() { 
		return (length);
	}

}
