package did.xml;

import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;

/*****************************************************************************************
*<pre>
*File:         DIDTreeModelListener.java
*Version:      1.1
*Description:  This class was intended to listen to the DIDTree and respond to certain 
*events initiated by the user.  Because of time contraints and implmentation issues this 
*class was not fully implmented but left so that future versions could take advantage of 
*the methods and functionality exposed by this class.
*Specifically this class could be used to listen when a user changes the value of a 
*userObject in a node that contains coordinate data.  The ROI the coordinate is a part of
*could then be update providing the user with a more robust way to edit data.
*Modification Log:
*Date          Name    Comment
*xx-xx-xxxx    XXX	   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*</pre>
******************************************************************************************/

public class DIDTreeModelListener implements TreeModelListener {

	/*****************************************************************************************
	* Method used to instantiate the class.
	*****************************************************************************************/   
	public DIDTreeModelListener() { }

	/*****************************************************************************************
	* Method triggered when a node has been altered.
	* @param TreeModelEvent Encapsulates information describing changes to a tree model, and 
	* used to notify tree model listeners of the change. 
	*****************************************************************************************/   
	public void treeNodesChanged(TreeModelEvent e) { 
		//System.out.println(((DIDNode)e.getTreePath().getLastPathComponent()).getFirstChild());
	}

	/*****************************************************************************************
	* Method triggered when a node has been inserted.
	* @param TreeModelEvent Encapsulates information describing changes to a tree model, and 
	* used to notify tree model listeners of the change. 
	*****************************************************************************************/   
	public void treeNodesInserted(TreeModelEvent e) { }

	/*****************************************************************************************
	* Method triggered when a node has been removed.
	* @param TreeModelEvent Encapsulates information describing changes to a tree model, and 
	* used to notify tree model listeners of the change. 
	*****************************************************************************************/   
	public void treeNodesRemoved(TreeModelEvent e) { }

	/*****************************************************************************************
	* Method triggered when a large portion of the underlying tree structure of the data model
	* this class is listening to has changed.
	* @param TreeModelEvent Encapsulates information describing changes to a tree model, and 
	* used to notify tree model listeners of the change. 
	*****************************************************************************************/   
	public void treeStructureChanged(TreeModelEvent e) { }
}