%{

#include "y.tab.h"

int lineno = 1;
//void yyerror(char *s);
#define iDocument "Document"
#define iNewLine "NewLine"
#define iParagraph "Paragraph"
#define iRegion "Region"
#define iSpace "Space"
#define iLine "Line"
#define iZone "Zone"
#define iWord "Word"
#define iGlyph "Glyph"
#define iComment "Comment"


%}
%%

[\t ]+		;

"<"		{ /*printf("<LT>");*/ return LT; } 
">"		{ /*printf("<GT>\n");*/ return GT; } 
"<?"		{ /*printf("<L?>");*/ return LT_QUEST; } 
"?>"		{ /*printf("<G?>\n");*/ return GT_QUEST; } 
"<!".*">"	{ /*printf("<L!>");*/ yylval.sval = yytext; return COMMENT; } 
"</"		{ /*printf("<L/>");*/ return LT_SLASH; } 
"/>"		{ /*printf("<R/>\n");*/ return GT_SLASH; } 
"="		{ /*printf("<EQ>");*/ return EQUAL; } 
\"[^"]*\"	{ /*printf("<ST>");*/ yylval.sval = yytext; return STRING; } 

Document |
NewLine |
Paragraph |
Region |
Space |
Line |
Zone |
Word |
Glyph |
Comment		{ yylval.sval = yytext; return ELE_NAME; }

GT_TEXT		{ yylval.sval = yytext; return GT_TEXT; }

Vertex		{ yylval.sval = yytext; return VERTEX; }

DocumentCorners |
NewLineCorners |
ParagraphCorners |
RegionCorners |
SpaceCorners |
LineCorners |
ZoneCorners |
WordCorners |
GlyphCorners |
CommentCorners		{ yylval.sval = yytext; return BOX; }

[a-zA-Z][-_a-zA-Z0-9]*  { /*printf("<VA %s>", yytext);*/ yylval.sval = yytext; return VARIABLE; } 
.		{ yylval.cval = yytext[0]; return CHARACTER; } 
\n		{ lineno++; }

%%

//void yyerror(char *s) {
//  printf("%d: %s at %s\n", lineno, s, yytext);
//}


//main(int argc, char **argv) {
//  yylex();
//  yyparse();
//}

